﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.ServiceModel;
using HeuristicLab.Services.Authentication.DataTransfer;
using HeuristicLab.Services.Authentication.DataAccess;
using System.Data.Linq;

namespace HeuristicLab.Services.Authentication
{
    [ServiceBehavior(IncludeExceptionDetailInFaults = true)]
    public class AuthenticationService : IAuthenticationService
    {
        #region User

        public DataTransfer.User GetUser(Guid id)
        {

            using (UserManagementDataContext db = new UserManagementDataContext())
            {
                Table<aspnet_User> UserTable = db.GetTable<aspnet_User>();

                var User = from item in UserTable
                           where item.UserId == id
                          select item;
               return Convert.ToDataTransfer((aspnet_User)User);
            }
         
            
        }
        public IEnumerable<DataTransfer.User> GetUsers()
        {
            List<DataTransfer.User> UserList = new List<DataTransfer.User>();

            using (UserManagementDataContext db = new UserManagementDataContext())
            {
                Table<aspnet_User> UserTable = db.GetTable<aspnet_User>();

                var Users = from item in UserTable
                           select item;
                foreach (var User in Users)
                {
                    UserList.Add( Convert.ToDataTransfer((aspnet_User)User));
                }
            }


            return UserList;
        }
        public bool InsertUser(User user)
        {
            // insert user
            if (user != null)
            {
                using (UserManagementDataContext db = new UserManagementDataContext())
                {
                    try
                    {
                        aspnet_User userDa = Convert.ToEntity(user);
                        db.aspnet_Users.InsertOnSubmit(userDa);
                        db.SubmitChanges();
                    }
                    catch (Exception e)
                    {
                        return false;
                    }
                }
                return true;
            }
            return false;
        }
        public bool DeleteUser(Guid id)
        {

            return false;
        }
        public bool UpdateUser(User user)
        {
            return false;
        }

        #endregion


        #region Role

        public Role GetRole(Guid id)
        {
            Role role = new Role();
            // ...

            return role;
        }
        public IEnumerable<Role> GetRoles()
        {
            List<Role> RoleList = new List<Role>();

            using (UserManagementDataContext db = new UserManagementDataContext())
            {
                Table<aspnet_Role> RoleTable = db.GetTable<aspnet_Role>();

                var Roles = from item in RoleTable
                            select item;
                foreach (var Role in Roles)
                {
                    RoleList.Add(Convert.ToDataTransfer((aspnet_Role)Role));
                }
            }

            return RoleList;
        }
        public bool InsertRole(Role role)
        {
            if (role != null)
            {
                using (UserManagementDataContext db = new UserManagementDataContext())
                {
                    try
                    {
                        aspnet_Role roleDa = Convert.ToEntity(role);
                        db.aspnet_Roles.InsertOnSubmit(roleDa);
                        db.SubmitChanges();
                    }
                    catch (Exception e)
                    {
                        return false;
                    }
                }
                return true;
            }
            return false;
        }
        public bool UpdateRole(Role role)
        {
            return false;
        }
        public bool DeleteRole(Guid id)
        {
            return false;
        }
        public bool AddRoleToUser(Guid roleId, Guid userId)
        {
            return false;
        }
        public bool RemoveRoleFromUser(Guid roleId, Guid userId)
        {
            return false;
        }
        public IEnumerable<Role> GetRolesForUser(Guid userId)
        {
            List<Role> roles = new List<Role>();
            return roles;
        }

        #endregion
    }
}

