﻿using System;
using System.Collections.Generic;
using HeuristicLab.Services.Authentication.DataTransfer;
using System.ServiceModel;
using System.Net.Security;

namespace HeuristicLab.Services.Authentication
{
    [ServiceContract(ProtectionLevel = ProtectionLevel.EncryptAndSign)]
    public interface IAuthenticationService
    {
        #region User

        [OperationContract]
        User GetUser(Guid id);

        [OperationContract]
        IEnumerable<User> GetUsers();

        [OperationContract]
        bool InsertUser(User user);

        [OperationContract]
        bool DeleteUser(Guid id);

        [OperationContract]
        bool UpdateUser(User user);

        #endregion

        #region Role

        [OperationContract]
        Role GetRole(Guid id);

        [OperationContract]
        IEnumerable<Role> GetRoles();

        [OperationContract]
        bool InsertRole(Role role);

        [OperationContract]
        bool UpdateRole(Role role);

        [OperationContract]
        bool DeleteRole(Guid id);

        [OperationContract]
        bool AddRoleToUser(Guid roleId, Guid userId);

        [OperationContract]
        bool RemoveRoleFromUser(Guid roleId, Guid userId);

        [OperationContract]
        IEnumerable<Role> GetRolesForUser(Guid userId);

        #endregion
    }
}
